%{?scl:%scl_package libomp}
%{!?scl:%global pkg_name %{name}}

#%%global rc_ver 2
%global libomp_srcdir openmp-%{version}%{?rc_ver:rc%{rc_ver}}.src


%ifarch ppc64le
%global libomp_arch ppc64
%else
%global libomp_arch %{_arch}
%endif

%ifnarch i686
%global enable_test_pkg 1
%endif

Name: %{?scl_prefix}libomp
Version: 9.0.1
Release: 1%{?rc_ver:.rc%{rc_ver}}%{?dist}
Summary: OpenMP runtime for clang

License: NCSA
URL: http://openmp.llvm.org	
Source0: http://%{?rc_ver:pre}releases.llvm.org/%{version}/%{?rc_ver:rc%{rc_ver}}/%{libomp_srcdir}.tar.xz
Source1: run-lit-tests
Source2: lit.fedora.cfg.py

Patch0: 0001-CMake-Make-LIBOMP_HEADERS_INSTALL_PATH-a-cache-varia.patch
Patch1: 0001-openmp-Use-glibc-wrappers-for-accessing-cpu-affinity.patch
Patch2: 0001-Remove-some-inline-assemly-rejected-by-gcc-4.patch

BuildRequires:	%{?scl_prefix}cmake
BuildRequires: elfutils-libelf-devel
BuildRequires: perl
BuildRequires: perl-Data-Dumper
BuildRequires: perl-Encode
BuildRequires: libffi-devel

Requires: elfutils-libelf%{?isa}

# libomp does not support s390x.
ExcludeArch: s390x

%description
OpenMP runtime for clang.

%package devel
Summary: OpenMP header files
Requires: %{?scl_prefix}clang-devel%{?isa} = %{version}

%description devel
OpenMP header files.

%if 0%{?enable_test_pkg}

%package test
Summary: OpenMP regression tests
Requires: %{?scl_prefix}libomp%{?isa} = %{version}
Requires: %{?scl_prefix}libomp-devel%{?isa} = %{version}
Requires: %{?scl_prefix}clang
Requires: %{?scl_prefix}llvm
Requires: gcc
Requires: gcc-c++
Requires: %{?scl_prefix}python2-lit

%description test
OpenMP regression tests

%endif

%prep
%autosetup -n openmp-%{version}%{?rc_ver:rc%{rc_ver}}.src -p2

%build
mkdir -p _build
cd _build

%cmake .. \
	-DLIBOMP_INSTALL_ALIASES=OFF \
	-DLIBOMP_HEADERS_INSTALL_PATH:PATH=%{_libdir}/clang/%{version}/include \
%if 0%{?__isa_bits} == 64
	-DOPENMP_LIBDIR_SUFFIX=64 \
%else
	-DOPENMP_LIBDIR_SUFFIX= \
%endif

%make_build


%install
%make_install -C _build

%if 0%{?enable_test_pkg}

# Test package setup
%global libomp_srcdir %{_datadir}/libomp/src/
%global libomp_testdir %{libomp_srcdir}/runtime/test/
%global lit_cfg %{libomp_testdir}/%{_arch}.site.cfg.py
%global lit_fedora_cfg %{_datadir}/libomp/lit.fedora.cfg.py

install -d %{buildroot}%{libomp_srcdir}/runtime
cp -R runtime/test  %{buildroot}%{libomp_srcdir}/runtime
cp -R runtime/src  %{buildroot}%{libomp_srcdir}/runtime

# Remove patch backups that get installed
find %{buildroot}%{libomp_srcdir} -iname '*.orig' -exec rm -f {} \;

# Add symlinks to the libomp headers/library so gcc can find them.
ln -s %{_libdir}/clang/%{version}/include/omp.h %{buildroot}%{libomp_testdir}/omp.h
ln -s %{_libdir}/clang/%{version}/include/ompt.h %{buildroot}%{libomp_testdir}/ompt.h
ln -s %{_libdir}/clang/%{version}/include/omp-tools.h %{buildroot}%{libomp_testdir}/omp-tools.h
ln -s %{_libdir}/libomp.so %{buildroot}%{libomp_testdir}/libgomp.so

# Generate lit config files.  Strip off the last line that initiates the
# test run, so we can customize the configuration.
head -n -1 _build/runtime/test/lit.site.cfg >> %{buildroot}%{lit_cfg}

# Install custom fedora config file
cp %{SOURCE2} %{buildroot}%{lit_fedora_cfg}

# Patch lit config files to load custom fedora config
echo "lit_config.load_config(config, '%{lit_fedora_cfg}')" >> %{buildroot}%{lit_cfg}

# Install test script
install -d %{buildroot}%{_libexecdir}/tests/libomp
install -m 0755 %{SOURCE1} %{buildroot}%{_libexecdir}/tests/libomp

%endif

%files
%{_libdir}/libomp.so
%{_libdir}/libomptarget.so
%ifnarch %{arm} %{ix86}
%{_libdir}/libomptarget.rtl.%{libomp_arch}.so
%endif

%files devel
%{_libdir}/clang/%{version}/include/omp.h
%ifnarch %{arm}
%{_libdir}/clang/%{version}/include/omp-tools.h
%{_libdir}/clang/%{version}/include/ompt.h
%endif

%if 0%{?enable_test_pkg}
%files test
%{_datadir}/libomp
%{_libexecdir}/tests/libomp/
%endif


%changelog
* Mon Jan 27 2020 Tom Stellard <tstellar@redhat.com> - 9.0.1-1
- 9.0.1 Release

* Wed Aug 28 2019 sguelton@redhat.com - 8.0.1-3
- Remove __cmake hack

* Thu Aug 1 2019 sguelton@redhat.com - 8.0.1-2
- Update cmake dependency

* Mon Jul 29 2019 sguelton@redhat.com - 8.0.1-1
- 8.0.1 Release

* Thu Jan 10 2019 Tom Stellard <tstellar@redhat.com> - 7.0.1-2
- Rebuild for i686

* Wed Jan 09 2019 Tom Stellard <tstellar@redhat.com> - 7.0.1-1
- 7.0.1 Release

* Tue Sep 11 2018 Tom Stellard <tstellar@redhat.com> - 6.0.1-7
- Don't install patch backup files

* Tue Sep 11 2018 Tom Stellard <tstellar@redhat.com> - 6.0.1-6
- Drop libatomic test dependency on ppc64le

* Tue Sep 11 2018 Tom Stellard <tstellar@redhat.com> - 6.0.1-5
- Fix lit test failures on ppc64

* Mon Sep 10 2018 Tom Stellard <tstellar@redhat.com> - 6.0.1-4
- Remove gcc tests from runtest.sh

* Mon Sep 10 2018 Tom Stellard <tstellar@redhat.com> - 6.0.1-3
- Fix path in runtest.sh

* Sat Sep 08 2018 Edjunior Barbosa Machado <emachado@redhat.com> - 6.0.1-2
- Depend on python2 instead of python3

* Wed Jul 11 2018 Tom Stellard <tstellar@redhat.com> - 6.0.1-1
- 6.0.1 Release

* Mon Jan 15 2018 Tom Stellard <tstellar@redhat.com> - 5.0.1-2
- Rebuild to include i686

* Thu Dec 21 2017 Tom Stellard <tstellar@redhat.com> - 5.0.1-1
- 5.0.1 Release.

* Wed Jun 21 2017 Tom Stellard <tstellar@redhat.com> - 4.0.1-1
- 4.0.1 Release.

* Wed Jun 07 2017 Tom Stellard <tstellar@redhat.com> - 4.0.0-3
- Rename libopenmp->libomp

* Fri May 26 2017 Tom Stellard <tstellar@redhat.com> - 4.0.0-2
- Disable build on s390x

* Mon May 15 2017 Tom Stellard <tstellar@redhat.com> - 4.0.0-1
- Initial version.
